' ----------------------------------------------------------------------------------------
'
' TaktStrasse.VB                                               Ulrich Mller     16.01.05
'                                                              PCS1700   VB.NET Final SP2
' Trainingsmodell 51 664 : Taktstrae, MultiThread-Version
' Die einzelnen Bearbeitungsstationen laufen jeweils in eigenen Threads simultan
' die Bearbeitungsschritte werden gleichzeitig gestartet
' mit FishFa30.DLL auf Basis von umFish30.DLL
' Einsatz von Intelligent Interface mit Extension Module
' oder        ROBO Interface mit I/O-Extension, beide im Online Mode.
'
' ----------------------------------------------------------------------------------------

Imports System.Threading
Imports FishFa30

Public Class frmMain
	Inherits System.Windows.Forms.Form

#Region " Vom Windows Form Designer generierter Code "

	Public Sub New()
		MyBase.New()

		' Dieser Aufruf ist fr den Windows Form-Designer erforderlich.
		InitializeComponent()

		' Initialisierungen nach dem Aufruf InitializeComponent() hinzufgen

	End Sub

	' Die Form berschreibt den Lschvorgang der Basisklasse, um Komponenten zu bereinigen.
	Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
		If disposing Then
			If Not (components Is Nothing) Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(disposing)
	End Sub

	' Fr Windows Form-Designer erforderlich
	Private components As System.ComponentModel.IContainer

	'HINWEIS: Die folgende Prozedur ist fr den Windows Form-Designer erforderlich
	'Sie kann mit dem Windows Form-Designer modifiziert werden.
	'Verwenden Sie nicht den Code-Editor zur Bearbeitung.
	Friend WithEvents PictureBox1 As System.Windows.Forms.PictureBox
	Friend WithEvents PictureBox2 As System.Windows.Forms.PictureBox
	Friend WithEvents lblStatus As System.Windows.Forms.Label
	Friend WithEvents cmdAction As System.Windows.Forms.Button
	Friend WithEvents cmdEnde As System.Windows.Forms.Button
	Friend WithEvents cboPortName As System.Windows.Forms.ComboBox
	Friend WithEvents lblAblage As System.Windows.Forms.Label
	Friend WithEvents lblBohren As System.Windows.Forms.Label
	Friend WithEvents lblPutzen As System.Windows.Forms.Label
	Friend WithEvents lblZufuhr As System.Windows.Forms.Label
	<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
		Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(frmMain))
		Me.PictureBox1 = New System.Windows.Forms.PictureBox()
		Me.PictureBox2 = New System.Windows.Forms.PictureBox()
		Me.cmdAction = New System.Windows.Forms.Button()
		Me.cmdEnde = New System.Windows.Forms.Button()
		Me.cboPortName = New System.Windows.Forms.ComboBox()
		Me.lblStatus = New System.Windows.Forms.Label()
		Me.lblAblage = New System.Windows.Forms.Label()
		Me.lblBohren = New System.Windows.Forms.Label()
		Me.lblPutzen = New System.Windows.Forms.Label()
		Me.lblZufuhr = New System.Windows.Forms.Label()
		Me.SuspendLayout()
		'
		'PictureBox1
		'
		Me.PictureBox1.Image = CType(resources.GetObject("PictureBox1.Image"), System.Drawing.Bitmap)
		Me.PictureBox1.Location = New System.Drawing.Point(24, 24)
		Me.PictureBox1.Name = "PictureBox1"
		Me.PictureBox1.Size = New System.Drawing.Size(560, 392)
		Me.PictureBox1.TabIndex = 0
		Me.PictureBox1.TabStop = False
		'
		'PictureBox2
		'
		Me.PictureBox2.Image = CType(resources.GetObject("PictureBox2.Image"), System.Drawing.Bitmap)
		Me.PictureBox2.Location = New System.Drawing.Point(696, 32)
		Me.PictureBox2.Name = "PictureBox2"
		Me.PictureBox2.Size = New System.Drawing.Size(32, 32)
		Me.PictureBox2.TabIndex = 1
		Me.PictureBox2.TabStop = False
		'
		'cmdAction
		'
		Me.cmdAction.Location = New System.Drawing.Point(632, 376)
		Me.cmdAction.Name = "cmdAction"
		Me.cmdAction.Size = New System.Drawing.Size(104, 32)
		Me.cmdAction.TabIndex = 2
		Me.cmdAction.Text = "&START"
		'
		'cmdEnde
		'
		Me.cmdEnde.DialogResult = System.Windows.Forms.DialogResult.Cancel
		Me.cmdEnde.Location = New System.Drawing.Point(632, 336)
		Me.cmdEnde.Name = "cmdEnde"
		Me.cmdEnde.Size = New System.Drawing.Size(104, 32)
		Me.cmdEnde.TabIndex = 3
		Me.cmdEnde.Text = "&ENDE"
		'
		'cboPortName
		'
		Me.cboPortName.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList
		Me.cboPortName.Items.AddRange(New Object() {"LST", "COM1", "COM2", "COM3", "COM4"})
		Me.cboPortName.Location = New System.Drawing.Point(632, 296)
		Me.cboPortName.Name = "cboPortName"
		Me.cboPortName.Size = New System.Drawing.Size(104, 21)
		Me.cboPortName.TabIndex = 4
		'
		'lblStatus
		'
		Me.lblStatus.Location = New System.Drawing.Point(600, 256)
		Me.lblStatus.Name = "lblStatus"
		Me.lblStatus.Size = New System.Drawing.Size(150, 16)
		Me.lblStatus.TabIndex = 5
		Me.lblStatus.Text = "Status"
		'
		'lblAblage
		'
		Me.lblAblage.Location = New System.Drawing.Point(600, 160)
		Me.lblAblage.Name = "lblAblage"
		Me.lblAblage.Size = New System.Drawing.Size(150, 16)
		Me.lblAblage.TabIndex = 7
		Me.lblAblage.Text = "Ablage "
		'
		'lblBohren
		'
		Me.lblBohren.Location = New System.Drawing.Point(600, 184)
		Me.lblBohren.Name = "lblBohren"
		Me.lblBohren.Size = New System.Drawing.Size(150, 16)
		Me.lblBohren.TabIndex = 8
		Me.lblBohren.Text = "Bohren"
		'
		'lblPutzen
		'
		Me.lblPutzen.Location = New System.Drawing.Point(600, 208)
		Me.lblPutzen.Name = "lblPutzen"
		Me.lblPutzen.Size = New System.Drawing.Size(150, 16)
		Me.lblPutzen.TabIndex = 9
		Me.lblPutzen.Text = "Putzen"
		'
		'lblZufuhr
		'
		Me.lblZufuhr.Location = New System.Drawing.Point(600, 232)
		Me.lblZufuhr.Name = "lblZufuhr"
		Me.lblZufuhr.Size = New System.Drawing.Size(150, 16)
		Me.lblZufuhr.TabIndex = 10
		Me.lblZufuhr.Text = "Zufuhr"
		'
		'frmMain
		'
		Me.AcceptButton = Me.cmdAction
		Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
		Me.CancelButton = Me.cmdEnde
		Me.ClientSize = New System.Drawing.Size(768, 445)
		Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.lblZufuhr, Me.lblPutzen, Me.lblBohren, Me.lblAblage, Me.lblStatus, Me.cboPortName, Me.cmdEnde, Me.cmdAction, Me.PictureBox2, Me.PictureBox1})
		Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
		Me.MaximizeBox = False
		Me.Name = "frmMain"
		Me.Text = "Trainingsmodell 51 664 : Taktstrae"
		Me.ResumeLayout(False)

	End Sub

#End Region

	' --- FishFace, Threads -------------------------------------------------

	Dim ft As New FishFace(False, True, 0)
	Dim KontrollThread As Thread
	Dim ZufuhrThread As Thread
	Dim PutzenThread As Thread
	Dim BohrenThread As Thread
	Dim AblageThread As Thread

	Dim ZufuhrReady As AutoResetEvent
	Dim PutzenReady As AutoResetEvent
	Dim BohrenReady As AutoResetEvent
	Dim AblageReady As AutoResetEvent

	Dim AllReady As ManualResetEvent

	Dim Abschalten As Boolean

	' --- Interface-Belegung -----------------------------------------------------

	Const zfBandMotor = 1, zfPhotoEin = 1, zfPhotoAus = 2
	Const ptBandMotor = 2, ptSchieberMotor = 3, ptRuckTaster = 3, ptVorTaster = 4
	Const ptPutzMotor = 4, ptPhotoEin = 5
	Const bhBandMotor = 5, bhBohrMotor = 6, bhPhotoEin = 9
	Const agBandMotor = 7, agSchieberMotor = 8, agRuckTaster = 10
	Const agVorTaster = 11, agPhotoEin = 12
	Const ftiEin = 1, ftiAus = 0, ftiLinks = 1, ftiRechts = 2

	Private Sub frmMain_Closing(ByVal sender As Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing
		If cmdEnde.Text = "&HALT" Then e.Cancel = True
	End Sub

	Private Sub frmMain_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
		cboPortName.SelectedIndex = 2
	End Sub
	' --- Beenden des Modellbetriebs bei Button HALT
	'             des Programms      bei Button ENDE
	Private Sub cmdEnde_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
		If cmdEnde.Text = "&HALT" Then
			Abschalten = True
			ft.NotHalt = True
			lblStatus.Text = "Taktstrae fhrt runter"
			lblStatus.BackColor = Color.Yellow
			Application.DoEvents()

			' --- Auslaufphase : hier unterbringen ------------
			lblStatus.Text = "Taktstrae in Auslaufphase"

			ft.CloseInterface()
			lblStatus.Text = "Taktstrae abgeschaltet"
			lblStatus.BackColor = Color.Gray
			cmdEnde.Text = "&ENDE"
			cmdAction.Enabled = True
			Application.DoEvents()
		Else
			Me.Close()
		End If
	End Sub
	' --- cmdAction_Click : Steuern des Modellbetriebes ---------------------------

	Private Sub cmdAction_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles cmdAction.Click
		Try
			ft.OpenInterface(cboPortName.SelectedIndex)

			' --- Threads instanzieren -------------------------------------------
			KontrollThread = New Thread(AddressOf KontrollExecute)
			ZufuhrThread = New Thread(AddressOf ZufuhrExecute)
			PutzenThread = New Thread(AddressOf PutzenExecucte)
			BohrenThread = New Thread(AddressOf BohrenExecute)
			AblageThread = New Thread(AddressOf AblageExecute)

			ZufuhrReady = New AutoResetEvent(False)
			PutzenReady = New AutoResetEvent(False)
			BohrenReady = New AutoResetEvent(False)
			AblageReady = New AutoResetEvent(False)

			AllReady = New ManualResetEvent(True)

			' --- Ready-Meldung --------------------------------------------
			cmdAction.Enabled = False
			cmdEnde.Text = "&HALT"
			lblStatus.Text = "Taktstrae gestartet"
			lblStatus.BackColor = Color.Yellow
			cmdEnde.Focus()

			' --- Anlaufphase -------------------------------------------------
			lblStatus.Text = "Taktstrae in Anlaufphase"
			Init()
			Zufuhr()
			Putzen()
			Bohren()
			Zufuhr()
			Putzen()
			Zufuhr()

			' --- Thread-Start --------------------------------------------
			ZufuhrThread.Start()
			PutzenThread.Start()
			BohrenThread.Start()
			AblageThread.Start()
			Abschalten = False
			lblStatus.Text = "Taktstrae in Betrieb"
			lblStatus.BackColor = Color.Green
			Application.DoEvents()
			Thread.Sleep(200)
			KontrollThread.Start()
		Catch eft As FishFaceException
			lblStatus.Text = eft.Message
			lblStatus.BackColor = Color.Red
		End Try
	End Sub

	' --- Thread Routinen -------------------------------------------
	Private Sub KontrollExecute()
		Do Until Abschalten
			AllReady.Reset()
			ZufuhrReady.WaitOne()
			PutzenReady.WaitOne()
			BohrenReady.WaitOne()
			AblageReady.WaitOne()
			AllReady.Set()
			Thread.Sleep(200)
		Loop
	End Sub

	Private Sub ZufuhrExecute()
		Do
			AllReady.WaitOne()
			Thread.Sleep(5000)					 ' --- Schieber Rck abwarten
			Zufuhr()
			ZufuhrReady.Set()
		Loop Until Abschalten
	End Sub

	Private Sub PutzenExecucte()
		Do
			AllReady.WaitOne()
			Putzen()
			PutzenReady.Set()
		Loop Until Abschalten
	End Sub

	Private Sub BohrenExecute()
		Do
			AllReady.WaitOne()
			Bohren()
			BohrenReady.Set()
		Loop Until Abschalten
	End Sub

	Private Sub AblageExecute()
		Do
			AllReady.WaitOne()
			Ablage()
			AblageReady.Set()
		Loop Until Abschalten
	End Sub

	' --- Routinen fr die Bearbeitungsstationen ---------------------------------
	Private Sub Zufuhr()
		lblZufuhr.Text = "Zufuhr gestartet"
		lblZufuhr.BackColor = Color.Green
		ft.WaitForLow(zfPhotoEin)
		ft.SetMotor(zfBandMotor, ftiLinks)
		ft.WaitForLow(zfPhotoAus)
		ft.WaitForTime(1500)
		ft.SetMotor(zfBandMotor, ftiAus)
		lblZufuhr.Text = "Zufuhr beendet"
		lblZufuhr.BackColor = Color.Gray
	End Sub

	Private Sub Putzen()
		lblPutzen.Text = "Putzen gestartet"
		lblPutzen.BackColor = Color.Green
		ft.SetMotor(ptSchieberMotor, ftiRechts)
		ft.SetMotor(ptBandMotor, ftiLinks)
		ft.WaitForInput(ptVorTaster)
		ft.SetMotor(ptSchieberMotor, ftiAus)
		ft.SetMotor(ptPutzMotor, ftiRechts)
		ft.WaitForLow(ptPhotoEin)
		ft.SetMotor(ptBandMotor, ftiAus)
		ft.SetMotor(ptSchieberMotor, ftiLinks)
		ft.WaitForInput(ptRuckTaster)
		ft.SetMotor(ptSchieberMotor, ftiAus)
		ft.WaitForTime(5000)
		ft.SetMotor(ptPutzMotor, ftiAus)
		ft.SetMotor(ptBandMotor, ftiLinks)
		ft.WaitForTime(2000)
		ft.SetMotor(ptBandMotor, ftiAus)
		lblPutzen.Text = "Putzen beendet"
		lblPutzen.BackColor = Color.Gray
	End Sub

	Private Sub Bohren()
		lblBohren.Text = "Bohren gestartet"
		lblBohren.BackColor = Color.Green
		ft.SetMotor(bhBandMotor, ftiLinks)
		ft.WaitForLow(bhPhotoEin)
		ft.SetMotor(bhBandMotor, ftiAus)
		ft.SetMotor(bhBohrMotor, ftiRechts)
		ft.WaitForTime(3000)
		ft.SetMotor(bhBohrMotor, ftiAus)
		ft.SetMotor(bhBandMotor, ftiLinks)
		ft.WaitForTime(2000)
		ft.SetMotor(bhBandMotor, ftiAus)
		lblBohren.Text = "Bohren beendet"
		lblBohren.BackColor = Color.Gray
	End Sub

	Private Sub Ablage()
		lblAblage.Text = "Ablage gestartet"
		lblAblage.BackColor = Color.Green
		ft.SetMotor(agSchieberMotor, ftiRechts)
		ft.SetMotor(agBandMotor, ftiLinks)
		ft.WaitForInput(agVorTaster)
		ft.SetMotor(agSchieberMotor, ftiAus)
		ft.WaitForLow(agPhotoEin)
		ft.WaitForTime(1000)
		ft.SetMotor(agBandMotor, ftiAus)
		ft.SetMotor(agSchieberMotor, ftiLinks)
		ft.WaitForInput(agRuckTaster)
		ft.SetMotor(agSchieberMotor, ftiAus)
		lblAblage.Text = "Ablage beendet"
		lblAblage.BackColor = Color.Gray
	End Sub

	Private Sub Init()
		ft.SetMotor(ptSchieberMotor, ftiLinks)
		ft.WaitForInput(ptRuckTaster)
		ft.SetMotor(ptSchieberMotor, ftiAus)
		ft.SetMotor(agSchieberMotor, ftiLinks)
		ft.WaitForInput(agRuckTaster)
		ft.SetMotor(agSchieberMotor, ftiAus)
	End Sub
End Class
